package com.xcheng.scannere3;

import android.os.Bundle;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.preference.SwitchPreference;
import android.util.Log;
import android.view.KeyEvent;

import java.util.ArrayList;

import android.content.SharedPreferences;
import com.xcheng.scannere3.E3Util;


public class AllModulesActivity extends PreferenceActivity implements
        Preference.OnPreferenceChangeListener {
    private static final String TAG = "AllModulesActivity";

    private final ArrayList<SwitchPreference> mSPList = new ArrayList<>();

    private SharedPreferences mSharePref;


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        addPreferencesFromResource(R.xml.all_modules_setting);
        createPreference();
        mSharePref = ScanUtil.getSharedPreferences(this);
    }

    private void createPreference() {
        if (mSPList.size() == 0) {
            for (int i = 0; i < ScanUtil.MAX_TYPE; i++) {
                SwitchPreference preference = new SwitchPreference(this);
                preference.setOnPreferenceChangeListener(this);
                preference.setKey(ScanUtil.SP_KEYS[i]);
                preference.setTitle(ScanUtil.SP_TITLE_RES[i]);
                mSPList.add(preference);
                getPreferenceScreen().addPreference(preference);
            }
        }
        Log.d(TAG, "size = " + mSPList.size());
    }

    @Override
    public boolean onPreferenceChange(Preference preference, Object objValue) {
        boolean checked = (Boolean) objValue;
        String symbology = preference.getTitle().toString();
        Log.d(TAG, "symbology = " + symbology + ": checked = " + checked);
        E3Util.setCodeTypeOnOff(symbology, checked);

        mSharePref.edit().putBoolean(preference.getKey(), checked).commit();

        return true;
    }

    @Override
    public void onResume() {
        super.onResume();
        updateState();
    }

    @Override
    public void onPause() {
        super.onPause();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        if (mSPList.size() > 0) {
            mSPList.clear();
        }
    }

    private void updateState() {

    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_FUNCTION
                || keyCode == KeyEvent.KEYCODE_F11) {
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public boolean onKeyUp(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_FUNCTION
                || keyCode == KeyEvent.KEYCODE_F11) {
            return true;
        }
        return super.onKeyUp(keyCode, event);
    }

}


