package com.xcheng.scannere3;

import android.app.Fragment;
import android.preference.PreferenceFragment;
import android.os.Bundle;
import android.os.Handler;
import android.os.HandlerThread;
import android.os.Looper;
import android.os.Message;
import android.os.Vibrator;
import android.os.AsyncTask;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.preference.ListPreference;
import android.preference.Preference;
import android.preference.PreferenceScreen;
import android.preference.PreferenceActivity;
import android.preference.SwitchPreference;
import android.util.Log;
import android.text.TextUtils;
import android.widget.Toast;
import java.util.ArrayList;
import java.util.List;
import android.preference.PreferenceManager;
import android.content.SharedPreferences;
import com.xcheng.scannere3.codesetting.BaseSetting;


public class ModuleSettingFragment extends PreferenceFragment implements
        Preference.OnPreferenceChangeListener {
    private static final String TAG = "ModuleSettingFragment";
    private static final String KEY_ALL_SETTING = "all_setting";

    //add by yangzhichao for t0581 20201020 start
    private static final boolean VAL_1D_SWITCH_ON = true;
    private static final boolean VAL_1D_SWITCH_OFF = false;
    private static final boolean VAL_2D_SWITCH_ON = true;
    private static final boolean VAL_2D_SWITCH_OFF = false;
    //add by yangzhichao for t0581 20201020 end

    private static final boolean VAL_ALL_SWITCH_ON = true;
    private static final boolean VAL_ALL_SWITCH_OFF = false;

    //add by yangzhichao for t0581 20201020 start
    private static final boolean SWITCH_1D_DEF_VAL = VAL_1D_SWITCH_OFF; // Default value if settings profile not exist.
    private static final boolean SWITCH_2D_DEF_VAL = VAL_2D_SWITCH_OFF; // Default value if settings profile not exist.
    //add by yangzhichao for t0581 20201020 end

    private static final boolean ALL_SWITCH_DEF_VAL = VAL_ALL_SWITCH_ON; // Default value if settings profile not exist.

    //add by yangzhichao for t0581 20201020 start
    private SwitchPreference m1DSwitchPref;
    private SwitchPreference m2DSwitchPref;
    //add by yangzhichao for t0581 20201020 end

    private SwitchPreference mAllSwitchPref;
    private SharedPreferences mSharePref;

    private Preference mAllSettingsPref;

    private boolean mEnabled = false;

    private void updateAllSwitchPrefUI() {
        boolean state = mSharePref.getBoolean(ScanUtil.KEY_ALL_SWITCH, ALL_SWITCH_DEF_VAL);
        mAllSettingsPref.setSummary(mSharePref.getString(KEY_ALL_SETTING, getResources().getString(R.string.text_off)));
        if (state == VAL_ALL_SWITCH_ON) {
            mAllSettingsPref.setEnabled(false);
            m1DSwitchPref.setEnabled(false);
            m2DSwitchPref.setEnabled(false);
            Log.d(TAG, "updateAllSwitchPrefUI 000");
        //modify by yangzhichao for t0581 20201021 start
        } else if(mSharePref.getBoolean(ScanUtil.KEY_1D_SWITCH, SWITCH_1D_DEF_VAL) 
            || mSharePref.getBoolean(ScanUtil.KEY_2D_SWITCH, SWITCH_2D_DEF_VAL)){
            mAllSettingsPref.setEnabled(false);
            m1DSwitchPref.setEnabled(true);
            m2DSwitchPref.setEnabled(true);
            Log.d(TAG, "updateAllSwitchPrefUI 111");
        }else {
            for (int i = 0;i < ScanUtil.MAX_TYPE; i++){
                if(mSharePref.getBoolean(ScanUtil.SP_KEYS[i], false)){
                    mAllSettingsPref.setEnabled(true);
                    m1DSwitchPref.setEnabled(false);
                    m2DSwitchPref.setEnabled(false);
                    Log.d(TAG, "updateAllSwitchPrefUI 222");
                    return;
                }
            }
            Log.d(TAG, "updateAllSwitchPrefUI 333");
            mAllSettingsPref.setEnabled(true);
            m1DSwitchPref.setEnabled(true);
            m2DSwitchPref.setEnabled(true);
        }
        //modify by yangzhichao for t0581 20201021 end

    }

    //add by yangzhichao for t0581 20201020 start
    private boolean updateAllSettingPrefUI() {
            for (int i = 0;i < ScanUtil.MAX_TYPE; i++){
                if(mSharePref.getBoolean(ScanUtil.SP_KEYS[i], false)){
                    m1DSwitchPref.setEnabled(false);
                    m2DSwitchPref.setEnabled(false);
                    mAllSettingsPref.setSummary(mSharePref.getString(KEY_ALL_SETTING, getResources().getString(R.string.text_on)));
                    return true;
                }
            }
            m1DSwitchPref.setEnabled(true);
            m2DSwitchPref.setEnabled(true);
            mAllSettingsPref.setSummary(mSharePref.getString(KEY_ALL_SETTING, getResources().getString(R.string.text_off)));
            return false;
    }
    private void update1DSwitchPrefUI() {
        boolean state1D = mSharePref.getBoolean(ScanUtil.KEY_1D_SWITCH, SWITCH_1D_DEF_VAL);
        boolean state2D = mSharePref.getBoolean(ScanUtil.KEY_2D_SWITCH, SWITCH_2D_DEF_VAL);

        if (state1D == VAL_1D_SWITCH_OFF && state2D == VAL_2D_SWITCH_OFF) {
            mAllSettingsPref.setEnabled(true);
        } else {
            mAllSettingsPref.setEnabled(false);
        }
    }

    private void update2DSwitchPrefUI() {
        boolean state1D = mSharePref.getBoolean(ScanUtil.KEY_1D_SWITCH, SWITCH_1D_DEF_VAL);
        boolean state2D = mSharePref.getBoolean(ScanUtil.KEY_2D_SWITCH, SWITCH_2D_DEF_VAL);

        if (state1D == VAL_1D_SWITCH_OFF && state2D == VAL_2D_SWITCH_OFF) {
            mAllSettingsPref.setEnabled(true);
        } else {
            mAllSettingsPref.setEnabled(false);
        }
    }

    //add by yangzhichao for t0581 20201020 end

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        mSharePref = BaseSetting.getSharedPreferences(this.getContext());

        addPreferencesFromResource(R.xml.barcode_module_setting);

        mAllSettingsPref = findPreference(KEY_ALL_SETTING);

        mAllSwitchPref = (SwitchPreference) findPreference(ScanUtil.KEY_ALL_SWITCH);
        mAllSwitchPref.setOnPreferenceChangeListener(this);

        //add by yangzhichao for t0581 20201020 start
        m1DSwitchPref = (SwitchPreference) findPreference(ScanUtil.KEY_1D_SWITCH);
        m1DSwitchPref.setOnPreferenceChangeListener(this);

        m2DSwitchPref = (SwitchPreference) findPreference(ScanUtil.KEY_2D_SWITCH);
        m2DSwitchPref.setOnPreferenceChangeListener(this);

        mAllSettingsPref.setSummary(mSharePref.getString(KEY_ALL_SETTING, getResources().getString(R.string.text_off)));
        //add by yangzhichao for t0581 20201020 end

    }

    @Override
    public boolean onPreferenceChange(Preference preference, Object objValue) {
        mEnabled = (Boolean) objValue;
        Log.d(TAG, "onPreferenceChange: mEnabled = " + mEnabled);
        //modify by yangzhichao for t0581 20201019 start
        if (preference == mAllSwitchPref) {
            if (mAllSwitchPref.isChecked() != mEnabled) {
                mSharePref.edit().putBoolean(ScanUtil.KEY_ALL_SWITCH, mEnabled).commit();
                // Apply all_setting items
                for (int i = 0;i < ScanUtil.MAX_TYPE; i++){
                    mSharePref.edit().putBoolean(ScanUtil.SP_KEYS[i], false).commit();
                }
                ScanUtil.setScan1DTypeStatus(mEnabled ,this.getContext());
                ScanUtil.setScan2DTypeStatus(mEnabled ,this.getContext());
                if (mAllSwitchPref != null) {
                    updateAllSwitchPrefUI();
                }
                m1DSwitchPref.setChecked(false);
                m2DSwitchPref.setChecked(false);
            }
        } else if (preference == mAllSettingsPref) {

        } else if (preference == m1DSwitchPref) {
            if (m1DSwitchPref.isChecked() != mEnabled) {
                mSharePref.edit().putBoolean(ScanUtil.KEY_1D_SWITCH, mEnabled).commit();
                if (m1DSwitchPref != null) {
                    update1DSwitchPrefUI();
                }
                ScanUtil.setScan1DTypeStatus(mEnabled, this.getContext());
            }
        } else if (preference == m2DSwitchPref) {
            if (m2DSwitchPref.isChecked() != mEnabled) {
                mSharePref.edit().putBoolean(ScanUtil.KEY_2D_SWITCH, mEnabled).commit();
                if (m2DSwitchPref != null) {
                    update2DSwitchPrefUI();
                }
                ScanUtil.setScan2DTypeStatus(mEnabled, this.getContext());
            }
        }
        //modify by yangzhichao for t0581 20201019 end
        return true;
    }

    @Override
    public void onResume() {
        super.onResume();
        boolean state = mSharePref.getBoolean(ScanUtil.KEY_ALL_SWITCH, ALL_SWITCH_DEF_VAL);
        
        if (mAllSwitchPref != null) {
            mAllSwitchPref.setChecked(state);
        }

        if (mAllSettingsPref != null) {
            updateAllSwitchPrefUI();
        }

        //add by yangzhichao for t0581 20201021 start
        if (mAllSwitchPref != null && !mAllSwitchPref.isChecked()) {
            updateAllSettingPrefUI();
        }
        boolean state1D = mSharePref.getBoolean(ScanUtil.KEY_1D_SWITCH, SWITCH_1D_DEF_VAL);
        boolean state2D = mSharePref.getBoolean(ScanUtil.KEY_2D_SWITCH, SWITCH_2D_DEF_VAL);
        if (m1DSwitchPref != null) {
            m1DSwitchPref.setChecked(state1D);
        }
        if (m2DSwitchPref != null) {
            m2DSwitchPref.setChecked(state2D);
        }
        //add by yangzhichao for t0581 20201021 end
    }

    @Override
    public void onPause() {
        super.onPause();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
    }
}


