package com.xcheng.scannere3.codesetting;

import android.os.Bundle;
import android.content.Context;
import android.content.SharedPreferences.Editor;
import android.preference.ListPreference;
import android.preference.SwitchPreference;
import android.preference.Preference;
import android.preference.PreferenceScreen;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.Preference.OnPreferenceClickListener;
import android.util.Log;
import android.text.TextUtils;
import com.xcheng.scannere3.R;
//add by yangzhichao for t0581 20201015 start
import com.xcheng.scannere3.XCScanner;
//add by yangzhichao for t0581 20201015 end

public class AztecCodeSetting extends BaseSetting {

    private static final String TAG = "AztecCodeSetting";

    private static final int INVERSE_PARM = 589;

    private static final String KEY_INVERSE = "aztec_inverce";
    //modify by yangzhichao for t0581 20201015 start
    private static final String KEY_MIN = "aztec_min";
    private static final String KEY_MAX = "aztec_max";

    private static final int MAX_LENGTH = 3823;
    private static final int MIN_LENGTH = 1;

    private Preference mMaxPref;
    private Preference mMinPref;
    private SwitchPreference mInversePref;
    //modify by yangzhichao for t0581 20201015 end

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //modify by yangzhichao for t0581 20201015 start
        /* //This logic conflicts with the main switch and should not be released.
        mInversePref = (SwitchPreference) createPreference(this, TYPE_SWTICH,
                KEY_INVERSE, getString(R.string.inverse_decoder_setting), XCScanner.TAG_AZTEC_ENABLED);
        //mInversePref.setChecked(BaseSetting.getSharedPreferences(this).getInt(KEY_INVERSE, -1) == 1);
        Log.d(TAG, "mInversePref = " + getDecoderTagValue(XCScanner.TAG_AZTEC_ENABLED));
        mInversePref.setChecked(getDecoderTagValue(XCScanner.TAG_AZTEC_ENABLED) == 3);

        mInversePref.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object objValue) {
                boolean checked = (Boolean) objValue;
                Editor editor = BaseSetting.getSharedPreferences(AztecCodeSetting.this).edit();
                editor.putInt(KEY_INVERSE, checked ? 1 : 0);
                editor.commit();
                setDecoderTag(XCScanner.TAG_AZTEC_ENABLED, checked ? 3 : 1);
                return true;
            }
        });
        */
        final String maxTitle = getString(R.string.setting_max_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMaxPref = createPreference(this, TYPE_PREFERENCE, KEY_MAX, maxTitle, XCScanner.TAG_AZTEC_MAX_LENGTH);
        int maxValue = getDecoderTagValue(XCScanner.TAG_AZTEC_MAX_LENGTH);
        if (maxValue != -1){
            mMaxPref.setSummary(Integer.toString(maxValue));
        }
        mMaxPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MAX);
                createMaxLengthDialog(AztecCodeSetting.this, preference, maxTitle,
                        MAX_LENGTH, MIN_LENGTH, XCScanner.TAG_AZTEC_MAX_LENGTH);
                return true;
            }
        });

        final String minTitle = getString(R.string.setting_min_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMinPref = createPreference(this, TYPE_PREFERENCE, KEY_MIN, minTitle, XCScanner.TAG_AZTEC_MIN_LENGTH);
        int minValue = getDecoderTagValue(XCScanner.TAG_AZTEC_MIN_LENGTH);
        if (minValue != -1){
            mMinPref.setSummary(Integer.toString(minValue));
        }
        mMinPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MIN);
                createMinLengthDialog(AztecCodeSetting.this, preference, minTitle,
                        MAX_LENGTH, MIN_LENGTH, XCScanner.TAG_AZTEC_MIN_LENGTH);
                return true;
            }
        });
        /*
        mInversePref = (ListPreference) createPreference(this, TYPE_LIST,
                KEY_INVERSE, getString(R.string.inverse_decoder_setting), INVERSE_PARM);
        mInversePref.setEntries(R.array.inverse_decoder_entries);
        mInversePref.setEntryValues(R.array.inverse_decoder_values);
        mInversePref.setDialogTitle(R.string.inverse_decoder_setting);
        int value = BaseSetting.getSharedPreferences(this).getInt(KEY_INVERSE, -1);
        if (value != -1){
            mInversePref.setValueIndex(value);
            updateListPreferenceSummary(mInversePref, value);
        }
        mInversePref.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object objValue) {
                Editor editor = BaseSetting.getSharedPreferences(AztecCodeSetting.this).edit();
                editor.putInt(KEY_INVERSE, new Integer((String) objValue));
                editor.commit();
                setParameter(INVERSE_PARM, new Integer((String) objValue));
                updateListPreferenceSummary((ListPreference)preference,
                        Long.parseLong((String) objValue));
                //add by yangzhichao for t0581 20201015 start
                
                //add by yangzhichao for t0581 20201015 end
                return true;
            }
        });
        */
        //modify by yangzhichao for t0581 20201015 end
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onPause() {
        super.onPause();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
