package com.xcheng.scannere3.codesetting;

import android.os.Bundle;
import android.content.Context;
import android.content.SharedPreferences.Editor;
import android.preference.ListPreference;
import android.preference.SwitchPreference;
import android.preference.Preference;
import android.preference.PreferenceScreen;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.Preference.OnPreferenceClickListener;
import android.util.Log;
import android.text.TextUtils;
import com.xcheng.scannere3.R;

//add by yangzhichao for t0581 20201017 start
import com.xcheng.scannere3.XCScanner;
//add by yangzhichao for t0581 20201017 end

public class Interleaved2of5Setting extends BaseSetting {

    private static final String TAG = "Interleaved2of5Setting";

    //modify by yangzhichao for t0581 20201022 start
    private static final int VERIFY_CHECK_DIGIT_PARM = 49;
    private static final int TRANSMIT_CHECK_DIGIT_PARM = XCScanner.TAG_I25_CHECK_DIGIT_MODE;
    private static final int MIN_LENGTH_PARM = XCScanner.TAG_I25_MIN_LENGTH;
    private static final int MAX_LENGTH_PARM = XCScanner.TAG_I25_MAX_LENGTH;
    //modify by yangzhichao for t0581 20201022 end

    private static final String KEY_VERIFY = "interleaved2of5_verify";
    private static final String KEY_TRANSMIT = "interleaved2of5_transmit";
    private static final String KEY_MIN = "interleaved2of5_min";
    private static final String KEY_MAX = "interleaved2of5_max";

    private static final int MAX_LENGTH = 127;
    private static final int MIN_LENGTH = 6;
    private static final int DFAULT_MIN_LENGTH = 14;

    private ListPreference mVerifyPref;
    private SwitchPreference mTransmitPref;
    private Preference mMaxPref;
    private Preference mMinPref;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //modify by yangzhichao for t0581 20201017 start
        /*
        mVerifyPref = (ListPreference) createPreference(this, TYPE_LIST,
                KEY_VERIFY, getString(R.string.verify_check_digit), VERIFY_CHECK_DIGIT_PARM);
        mVerifyPref.setEntries(R.array.check_digit_verification_entries);
        mVerifyPref.setEntryValues(R.array.check_digit_verification_values);
        mVerifyPref.setDialogTitle(R.string.verify_check_digit);
        int value = BaseSetting.getSharedPreferences(this).getInt(KEY_VERIFY, -1);
        if (value != -1){
            mVerifyPref.setValueIndex(value);
            updateListPreferenceSummary(mVerifyPref, value);
        }
        mVerifyPref.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object objValue) {
                Editor editor = BaseSetting.getSharedPreferences(Interleaved2of5Setting.this).edit();
                editor.putInt(KEY_VERIFY, new Integer((String) objValue));
                editor.commit();
                setParameter(VERIFY_CHECK_DIGIT_PARM, new Integer((String) objValue));
                updateListPreferenceSummary((ListPreference)preference,
                        Long.parseLong((String) objValue));
                return true;
            }
        });
        */

        mTransmitPref = (SwitchPreference) createPreference(this, TYPE_SWTICH,
                KEY_TRANSMIT, getString(R.string.transmit_check_digit), TRANSMIT_CHECK_DIGIT_PARM);
        //mTransmitPref.setChecked(BaseSetting.getSharedPreferences(this).getInt(KEY_TRANSMIT, -1) == 1);
        mTransmitPref.setChecked(getDecoderTagValue(TRANSMIT_CHECK_DIGIT_PARM) == 1);
        mTransmitPref.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object objValue) {
                boolean checked = (Boolean) objValue;
                Editor editor = BaseSetting.getSharedPreferences(Interleaved2of5Setting.this).edit();
                editor.putInt(KEY_TRANSMIT, checked ? 1 : 0);
                editor.commit();
                setParameter(TRANSMIT_CHECK_DIGIT_PARM, checked ? 1 : 0);
                return true;
            }
        });

        final String maxTitle = getString(R.string.setting_max_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMaxPref = createPreference(this, TYPE_PREFERENCE, KEY_MAX, maxTitle, MAX_LENGTH_PARM);
        //int maxValue = BaseSetting.getSharedPreferences(this).getInt(KEY_MAX, -1);
        int maxValue = getDecoderTagValue(MAX_LENGTH_PARM);
        if (maxValue != -1){
            mMaxPref.setSummary(Integer.toString(maxValue));
        } else {
            mMaxPref.setSummary(String.valueOf(MAX_LENGTH));
        }
        mMaxPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MAX);
                createMaxLengthDialog(Interleaved2of5Setting.this, preference, maxTitle,
                        MAX_LENGTH, MIN_LENGTH, MAX_LENGTH_PARM);
                return true;
            }
        });

        final String minTitle = getString(R.string.setting_min_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMinPref = createPreference(this, TYPE_PREFERENCE, KEY_MIN, minTitle, MIN_LENGTH_PARM);
        //int minValue = BaseSetting.getSharedPreferences(this).getInt(KEY_MIN, -1);
        int minValue = getDecoderTagValue(MIN_LENGTH_PARM);
        if (minValue != -1){
            mMinPref.setSummary(Integer.toString(minValue));
        } else {
            mMinPref.setSummary(String.valueOf(MIN_LENGTH));
        }
        mMinPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MIN);
                createMinLengthDialog(Interleaved2of5Setting.this, preference, minTitle,
                        MAX_LENGTH, MIN_LENGTH, MIN_LENGTH_PARM);
                return true;
            }
        });
        //modify by yangzhichao for t0581 20201017 end
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onPause() {
        super.onPause();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
