package com.xcheng.scannere3.codesetting;

import android.os.Bundle;
import android.content.Context;
import android.content.SharedPreferences.Editor;
import android.preference.ListPreference;
import android.preference.SwitchPreference;
import android.preference.Preference;
import android.preference.PreferenceScreen;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.Preference.OnPreferenceClickListener;
import android.util.Log;
import android.text.TextUtils;
import com.xcheng.scannere3.R;
//add by yangzhichao for t0581 20201017 start
import com.xcheng.scannere3.XCScanner;
//add by yangzhichao for t0581 20201017 end


public class MsiSetting extends BaseSetting {

    private static final String TAG = "MsiSetting";

    private static final int CHECK_DIGIT_PARM = 50;
    private static final int TRANSMIT_CHECK_DIGIT_PARM = XCScanner.TAG_MSI_CHECK_DIGIT_MODE;
    private static final int MIN_LENGTH_PARM = XCScanner.TAG_MSI_MIN_LENGTH;
    private static final int MAX_LENGTH_PARM = XCScanner.TAG_MSI_MAX_LENGTH;

    private static final String KEY_CHECK_DIGIT = "msi_check_digit";
    private static final String KEY_TRANSMIT_CHECK_DIGIT = "msi_transmit";
    private static final String KEY_MIN = "msi_min";
    private static final String KEY_MAX = "msi_max";

    private static final int MAX_LENGTH = 55;
    private static final int MIN_LENGTH = 0;
    private static final int DFAULT_MIN_LENGTH = 4;

    private ListPreference mDigitChekPref;
    private SwitchPreference mTransmitPref;
    private Preference mMaxPref;
    private Preference mMinPref;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //modify by yangzhichao for t0581 20201017 start
        /*
        mDigitChekPref = (ListPreference) createPreference(this, TYPE_LIST,
                KEY_CHECK_DIGIT, getString(R.string.check_digit), CHECK_DIGIT_PARM);
        mDigitChekPref.setEntries(R.array.check_digit_entries);
        mDigitChekPref.setEntryValues(R.array.check_digit_values);
        mDigitChekPref.setDialogTitle(R.string.check_digit);
        int value = BaseSetting.getSharedPreferences(this).getInt(KEY_CHECK_DIGIT, -1);
        if (value != -1){
            mDigitChekPref.setValueIndex(value);
            updateListPreferenceSummary(mDigitChekPref, value);
        }
        mDigitChekPref.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object objValue) {
                Editor editor = BaseSetting.getSharedPreferences(MsiSetting.this).edit();
                editor.putInt(KEY_CHECK_DIGIT, new Integer((String) objValue));
                editor.commit();
                setParameter(CHECK_DIGIT_PARM, new Integer((String) objValue));
                updateListPreferenceSummary((ListPreference)preference,
                        Long.parseLong((String) objValue));
                return true;
            }
        });

        */
        mTransmitPref = (SwitchPreference) createPreference(this, TYPE_SWTICH,
                KEY_TRANSMIT_CHECK_DIGIT, getString(R.string.transmit_check_digit), TRANSMIT_CHECK_DIGIT_PARM);
        //mTransmitPref.setChecked(BaseSetting.getSharedPreferences(this).getInt(KEY_TRANSMIT_CHECK_DIGIT, -1) == 1);
        mTransmitPref.setChecked(getDecoderTagValue(TRANSMIT_CHECK_DIGIT_PARM) == 1);
        mTransmitPref.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object objValue) {
                boolean checked = (Boolean) objValue;
                Editor editor = BaseSetting.getSharedPreferences(MsiSetting.this).edit();
                editor.putInt(KEY_TRANSMIT_CHECK_DIGIT, checked ? 1 : 0);
                editor.commit();
                setParameter(TRANSMIT_CHECK_DIGIT_PARM, checked ? 1 : 0);
                return true;
            }
        });
        final String maxTitle = getString(R.string.setting_max_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMaxPref = createPreference(this, TYPE_PREFERENCE, KEY_MAX, maxTitle, MAX_LENGTH_PARM);
        //int maxValue = BaseSetting.getSharedPreferences(this).getInt(KEY_MAX, -1);
        int maxValue = getDecoderTagValue(MAX_LENGTH_PARM);
        if (maxValue != -1){
            mMaxPref.setSummary(Integer.toString(maxValue));
        } else {
            mMaxPref.setSummary(String.valueOf(MAX_LENGTH));
        }
        mMaxPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MAX);
                createMaxLengthDialog(MsiSetting.this, preference, maxTitle,
                        MAX_LENGTH, MIN_LENGTH, MAX_LENGTH_PARM);
                return true;
            }
        });

        final String minTitle = getString(R.string.setting_min_length) + " (" + MIN_LENGTH + "-" + MAX_LENGTH + ")";
        mMinPref = createPreference(this, TYPE_PREFERENCE, KEY_MIN, minTitle, MIN_LENGTH_PARM);
        //int minValue = BaseSetting.getSharedPreferences(this).getInt(KEY_MIN, -1);
        int minValue = getDecoderTagValue(MIN_LENGTH_PARM);
        if (minValue != -1){
            mMinPref.setSummary(Integer.toString(minValue));
        } else {
            mMinPref.setSummary(String.valueOf(MIN_LENGTH));
        }
        mMinPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick(Preference preference) {
                preference.setKey(KEY_MIN);
                createMinLengthDialog(MsiSetting.this, preference, minTitle,
                        MAX_LENGTH, MIN_LENGTH, MIN_LENGTH_PARM);
                return true;
            }
        });
        //modify by yangzhichao for t0581 20201017 end
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onPause() {
        super.onPause();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
